package ru.dbotthepony.kstarbound.client.gl

import org.lwjgl.opengl.GL46.*

class VertexArrayObject(val state: GLStateTracker) {
	val pointer = glGenVertexArrays()

	init {
		checkForGLError()
		state.registerCleanable(this, ::glDeleteVertexArrays, pointer)
	}

	fun bind(): VertexArrayObject {
		return state.bind(this)
	}

	fun unbind(): VertexArrayObject {
		return state.unbind(this)
	}

	fun attribute(position: Int, size: Int, type: Int, normalize: Boolean, stride: Int, offset: Long = 0L): VertexArrayObject {
		state.ensureSameThread()
		glVertexAttribPointer(position, size, type, normalize, stride, offset)
		checkForGLError()
		return this
	}

	fun enableAttribute(position: Int): VertexArrayObject {
		state.ensureSameThread()
		glEnableVertexArrayAttrib(pointer, position)
		//glEnableVertexAttribArray(position)
		checkForGLError()
		return this
	}
}
